discussion/discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

discussion/todolist/urls.py
from django.urls import path
# import the views.py from the same folder
from . import views


app_name = 'todolist'

urlpatterns = [
	path('index', views.index, name = 'index'),
	path('todo/<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
    path('event/<int:eventitem_id>/', views.eventitem, name = "vieweventitem"),
	path('register', views.register, name = "register"),
	path('change_password', views.change_password, name = "change_password"),
	path('login', views.login_user, name = "login"),
	path('logout', views.logout_user, name = "logout"),
    path('add_task', views.add_task, name = "add_task"),
    path('add_event', views.add_event, name = "add_event"),
    path('todo/<int:todoitem_id>/update_task', views.update_task, name = "update_task"),
    path('todo/<int:todoitem_id>/delete_task', views.delete_task, name = "delete_task"),
    path('event/<int:eventitem_id>/update_event', views.update_event, name = "update_event"),
    path('event/<int:eventitem_id>/delete_event', views.delete_event, name = "delete_event"),
]

discussion/todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created')
	user= models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

class EventItem(models.Model):
	event_name = models.CharField(max_length = 50)
	description = models.CharField(max_length = 200)
	status =  models.CharField(max_length = 50, default = "pending")
	date_created = models.DateTimeField('date created')
	user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

discussion/todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label = "username", max_length = 20)
	password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label = 'task_name', max_length =50)
	description = forms.CharField(label = 'description', max_length = 200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label = "task_name", max_length = 50 )
	description = forms.CharField(label = "description", max_length = 200)
	status =  forms.CharField(label = "status", max_length =50)

class RegisterForm(forms.Form):
    username = forms.CharField(label='Username', max_length=20)
    firstname = forms.CharField(label='First Name', max_length=50)
    lastname = forms.CharField(label='Last Name', max_length=50)
    email = forms.EmailField(label='Email', max_length=50)
    password = forms.CharField(label='Password', max_length=50, widget=forms.PasswordInput)
    confirmPassword = forms.CharField(label='Confirm Password', max_length=50, widget=forms.PasswordInput)
    
class AddEventForm(forms.Form):
    event_name = forms.CharField(label = 'event_name', max_length = 50)
    description = forms.CharField(label = 'description', max_length = 200)
    
class UpdateEventForm(forms.Form):
	event_name = forms.CharField(label = "event_name", max_length = 50 )
	description = forms.CharField(label = "description", max_length = 200)
	status =  forms.CharField(label = "status", max_length =50)

class UpdateProfileForm(forms.Form):
	firstname = forms.CharField(label = "firstname", max_length = 50)
	lastname = forms.CharField(label = "lastname", max_length = 50)
	password =  forms.CharField(label = "Password", max_length =50)

discussion/todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.

# The from keyword allows importing of necessary classes/modules, methods and others files needed in our application from the django.http package while the import keyword defines what we are importing from the package
from django.http import HttpResponse

# Local imports
from .models import ToDoItem, EventItem

# import the built in User Model
from django.contrib.auth.models import User

# to use the template created:
# from django.template import loader

# import the authenticate function
from django.contrib.auth import authenticate, login, logout, update_session_auth_hash


from django.forms.models import model_to_dict

from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegisterForm, AddEventForm, UpdateEventForm, UpdateProfileForm

from django.utils import timezone

def index(request):
	eventitem_list = EventItem.objects.filter(user_id = request.user.id)
	todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
	# template = loader.get_template("index.html")
	context = {
		'todoitem_list': todoitem_list,
		'eventitem_list': eventitem_list,
		"user": request.user
	}
	# output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
	# render(request, route_template, context)
	return render(request, "index.html", context)

def todoitem(request, todoitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	todoitem = get_object_or_404(ToDoItem, pk = todoitem_id)

	return render(request, "todoitem.html", model_to_dict(todoitem))

def eventitem(request, eventitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	eventitem = get_object_or_404(EventItem, pk = eventitem_id)

	return render(request, "eventitem.html", model_to_dict(eventitem))



# this function is responsible for registering on our application
def register(request):
    if request.method == 'POST':
        form = RegisterForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data['username']
            first_name = form.cleaned_data['firstname']
            last_name = form.cleaned_data['lastname']
            email = form.cleaned_data['email']
            password = form.cleaned_data['password']
            confirm_password = form.cleaned_data['confirmPassword']

            if password != confirm_password:
                context = {
                    'error': True,
                    'form': form,
                }
                return render(request, 'register.html', context)

            else:
                # check if a user with the same username already exists
                if User.objects.filter(username=username).exists():
                    context = {
                        'form': form,
                        'error1': True,
                    }
                    return render(request, 'register.html', context)

                # check if a user with the same email already exists
                if User.objects.filter(email=email).exists():
                    context = {
                        'form': form,
                        'error2': True,
                    }
                    return render(request, 'register.html', context)

                # create a new user with the submitted data
                user = User.objects.create_user(username=username, email=email,
                                                password=password, first_name=first_name,
                                                last_name=last_name)
                # redirect to a success page or login page
                return redirect("todolist:login")

    else:
        form = RegisterForm()

    context = {
        'form': form,
    }
    return render(request, 'register.html', context)

# def change_password(request):

# 	is_user_authenticated = False

# 	user = authenticate(username = "johndoe", password = "johndoe123456")

# 	if user is not None:
# 		authenticated_user = User.objects.get(username = 'johndoe')
# 		authenticated_user.set_password("johndoe1234567")
# 		authenticated_user.save()

# 		is_user_authenticated = True

# 	context = {
# 		"is_user_authenticated" : is_user_authenticated
# 	}

# 	return render(request, "change_password.html", context)



def login_user(request):
	context = {}

	# if this is a post request we need to process the form data
	if request.method == "POST":

		form = LoginForm(request.POST)

		if form.is_valid() == False:
			form = LoginForm()
			
		else:
			print(form)
			# cleaned_data retrieves the information from the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']

			user = authenticate(username = username, password = password)

			if user is not None:
				context = {
					'username' : username,
					'password' : password
				}
				login(request, user)
				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}
			
	
	return render(request, "login.html", context)








	# username = 'johndoe'
	# password = 'johndoe1234567'

	# user = authenticate(username = username, password = password)

	

def logout_user(request):
	logout(request)
	return redirect("todolist:index")


def add_task(request):
	context = {}

	if request.method == 'POST':
		form = AddTaskForm(request.POST)

		if form.is_valid() == False:
			form = AddTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']

			duplicates = ToDoItem.objects.filter(task_name = task_name, user_id = request.user.id)

			if not duplicates:
				# create an ovbject based on the ToDoItem model and saves to the record in the database

				ToDoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}

	return render(request, "add_task.html", context)


def update_task(request, todoitem_id):

	todoitem = ToDoItem.objects.filter(pk = todoitem_id)
	print(todoitem)
	context = {
		"user": request.user,
		"todoitem_id": todoitem_id,
		"task_name": todoitem[0].task_name,
		"description": todoitem[0].description,
		"status" : todoitem[0].status
	}

	if request.method == "POST":
		form  = UpdateTaskForm (request.POST)

		if form.is_valid() == False:
			form = UpdateTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:

				todoitem[0].task_name = task_name
				todoitem[0].description = description
				todoitem[0].status = status

				todoitem[0].save()

				return redirect("todolist:viewtodoitem", todoitem_id =  todoitem[0].id)
			else:

				context = {
					"error" : True
				}

	return render(request, "update_task.html", context)

def delete_task(request, todoitem_id):

	ToDoItem.objects.filter(pk = todoitem_id).delete()

	return redirect("todolist:index")




def add_event(request):
	context = {}

	if request.method == 'POST':
		form = AddEventForm(request.POST)

		if form.is_valid() == False:
			form = AddEventForm()

		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']

			duplicates = EventItem.objects.filter(event_name = event_name, user_id = request.user.id)
			

			if not duplicates:
				# create an ovbject based on the ToDoItem model and saves to the record in the database

				EventItem.objects.create(event_name = event_name, description = description, date_created = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}

	return render(request, "add_event.html", context)



def update_event(request, eventitem_id):

	eventitem = EventItem.objects.filter(pk = eventitem_id)
	print(eventitem)
	context = {
		"user": request.user,
		"eventitem_id": eventitem_id,
		"event_name": eventitem[0].event_name,
		"description": eventitem[0].description,
		"status" : eventitem[0].status
	}

	if request.method == "POST":
		form  = UpdateEventForm (request.POST)

		if form.is_valid() == False:
			form = UpdateEventForm()

		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if eventitem:

				eventitem[0].event_name = event_name
				eventitem[0].description = description
				eventitem[0].status = status

				eventitem[0].save()

				return redirect("todolist:vieweventitem", eventitem_id =  eventitem[0].id)
			else:

				context = {
					"error" : True
				}

	return render(request, "update_event.html", context)

def delete_event(request, eventitem_id):

	EventItem.objects.filter(pk = eventitem_id).delete()

	return redirect("todolist:index")


def change_password(request):
    user = request.user

    if request.method == 'POST':
        # create form instance and populate it with data from the request
        form = UpdateProfileForm(request.POST)

        if form.is_valid():
            # process form data
            user.first_name = form.cleaned_data['firstname']
            user.last_name = form.cleaned_data['lastname']
            user.set_password(form.cleaned_data['password'])
            user.save()

            # update the user's session to prevent them from being logged out
            update_session_auth_hash(request, user)

        

            # redirect to the same page to avoid form resubmission
            return redirect('todolist:index')

    else:
        # create a blank form instance
        form = UpdateProfileForm()

    context = {
        'form': form,
        'user': user,
    }

    return render(request, 'change_password.html', context)

discussion/todolist/templates/add_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                {% if error == True %}
                    <p class = "text-danger">Duplicate Event Found!</p>
                {% endif %}
                <form action="{% url 'todolist:add_event' %}" method="POST">
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="event_name">Event Name: </label>
                        <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Add Event">
                    </div>

                </form>
            </div>
        </div>
    </div>
{% endblock %}

discussion/todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">
				{% if error == True %}
					<p class = "text-danger">Duplicate Task Found!</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="POST">
					
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Task Name: </label>
					    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>


{% endblock %}

discussion/todolist/templates/change_password.html
{% extends "base.html" %}

{% block title %}Change Password{% endblock %}

{% block content %}
    {% if user.is_authenticated %}
        <div class="container">
            <div class="row">
                <div class="col-6 offset-3">
                    <h1 class="text-center mt-3">Change Password</h1>

                    <form action="{% url 'todolist:change_password'%}" method="POST">
                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="firstname">First Name:</label>
                            <input class="form-control" type="text" name="firstname" value="{{ user.first_name }}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="lastname">Last Name:</label>
                            <input class="form-control" type="text" name="lastname" value="{{ user.last_name }}" maxlength="50" required>
                        </div>


                        <div class="mb-3">
                            <label for="password">New Password:</label>
                            <input class="form-control" type="password" name="password" required>
                        </div>

                     
                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Change Password">
                        </div>

                    </form>
                </div>

            </div>
        </div>
    {% else %}
        <p>Please log in to change your password.</p>
    {% endif %}
{% endblock %}

discussion/todolist/templates/eventitem.html
{% extends "base.html" %}

{% block title %}My Events{% endblock %}

{% block content %}
	<div class = "text-center mt-3">
		<h1>{{event_name}}</h1>

		<h3>Description:</h3>
		<p>{{description}}</p>

		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_event' id%}">Edit this event</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_event' id %}">Delete this event</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>
	

{% endblock %}

discussion/todolist/templates/index.html
{% extends 'base.html' %}

{%block title%}Home{% endblock %}

{% block content %}
	{% if todoitem_list and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>

		<div class = "container">
			<div class = 'row'>
				<h3 class = "text-center mb-3">My Tasks</h3>
				<ul class = " list-group text-center col-lg-4 offset-lg-4">
				{% for todoitem in todoitem_list %}
					<li class = "list-group-item"><a class = "text-decoration-none"href = "{% url 'todolist:viewtodoitem' todoitem.id %}">{{todoitem.task_name}}</a></li>
				{% endfor%}	
				</ul>
				<h3 class = "text-center mb-3">My Event</h3>
				<ul class = " list-group text-center col-lg-4 offset-lg-4">
				{% for eventitem in eventitem_list %}
					<li class = "list-group-item"><a class = "text-decoration-none"href = "{% url 'todolist:vieweventitem' eventitem.id %}">{{eventitem.event_name}}</a></li>
				{% endfor%}	
				</ul>
			</div>
		</div>

		
	{% elif todoitem_list.count == 0 and user.is_anonymous == False %}
		<h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
		<p class = "text-center my-3">No tasks have been created.</p>
	{%else%}
		<h1 class = "text-center my-3">You are not authorized to access this page.</h1>
		<p class = "text-center my-3">Kindly login <a href = "{% url 'todolist:login' %}">here</a>.</p>
	{% endif %}

{% endblock %}

discussion/todolist/templates/login.html
{% extends "base.html" %}

{% block title %}Login{% endblock %}

{% block content %}
	<h1 class = "text-center my-3">Login Form</h1>
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">

				{% if error == True %}
					<p class = "text-danger">Invalid credentials, please check your username and password or register first</p>
				{% endif %}
				
				<form action = "{% url 'todolist:login' %}" method = "POST">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains link, a from button or some javascript that is intended to perform some action in our website -->
					{% csrf_token %}
				  <div class="mb-3">
				    <label for="username" class="form-label">Username:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="username" 
				    	value = "{{ username }}"
				    	name = "username"
				    	maxlength = "20"
				    	required 
				    	>
				  </div>
				  <div class="mb-3">
				    <label for="password" class="form-label">Password:</label>
				    <input 
				    	type="password" 
				    	class="form-control" 
				    	id="password"
				    	name = "password"
				    	value = "{{ password }}"
				    	maxlength="20" 
				    	required
				    	>

				  </div>
				  
				  <button type="submit" class="btn btn-primary">Login</button>
				</form>
				
			</div>
			
		</div>
	</div>

{% endblock %}

discussion/todolist/templates/register.html
{% extends 'base.html' %}

{% block title %}Registration Form{% endblock %}

{% block content %}
<h1 class="text-center my-3">Registration Form</h1>
<div class="container">
    <div class="row">
        <div class="col-6 offset-3">
			{% if error == True %}
			<p class = "text-danger">Password didn't match</p>
			{% endif %}
			{% if error1 == True %}
			<p class = "text-danger">Username already taken</p>
			{% endif %}
			{% if error2 == True %}
			<p class = "text-danger">Email already taken</p>
			{% endif %}
            <form action="{% url 'todolist:register' %}" method="POST">
                {% csrf_token %}
                <div class="mb-3">
                    <label for="username" class="form-label">Username:</label>
                    <input type="text" class="form-control" id="username" name="username" value="{{ username }}" maxlength="20" required>
                </div>
                <div class="mb-3">
                    <label for="firstname" class="form-label">First Name:</label>
                    <input type="text" class="form-control" id="firstname" name="firstname" value="{{ firstname }}" maxlength="50" required>
                </div>
                <div class="mb-3">
                    <label for="lastname" class="form-label">Last Name:</label>
                    <input type="text" class="form-control" id="lastname" name="lastname" value="{{ lastname }}" maxlength="50" required>
                </div>
                <div class="mb-3">
                    <label for="email" class="form-label">Email:</label>
                    <input type="email" class="form-control" id="email" name="email" value="{{ email }}" maxlength="50" required>
                </div>
                <div class="mb-3">
                    <label for="password" class="form-label">Password:</label>
                    <input type="password" class="form-control" id="password" name="password" maxlength="50" required>
                </div>
                <div class="mb-3">
                    <label for="confirmPassword" class="form-label">Confirm Password:</label>
                    <input type="password" class="form-control" id="confirmPassword" name="confirmPassword" maxlength="50" required>
                </div>
                <button type="submit" class="col-4 offset-lg-4 btn btn-success">Register</button>
            </form>
        </div>
    </div>
</div>
{% endblock %}

discussion/todolist/templates/todoitem.html
{% extends "base.html" %}

{% block title %}My Tasks{% endblock %}

{% block content %}
	<div class = "text-center mt-3">
		<h1>{{task_name}}</h1>

		<h3>Description:</h3>
		<p>{{description}}</p>

		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_task' id%}">Edit this task</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_task' id %}">Delete this task</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>
	

{% endblock %}

discussion/todolist/templates/update_event.html
{% extends "base.html" %}

{% block title %}Update Event{% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class = "container">
			<div class = "row">
				<div class = "col-6 offset-3">
					<h1 class = "text-center mt-3">Update Event</h1>

					{% if error == True %}
						<p class = "text-danger text-center">Event not found</p>
					{% endif %}
					<form action="{% url 'todolist:update_event' eventitem_id %}" method="POST">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="event_name">Event Name: </label>
						    <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
						    <label for="status">Status: </label>
						    <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Update Event">
						</div>

					</form>
				</div>
				
			</div>
		</div>
	{% endif %}

{% endblock %}

discussion/todolist/templates/update_task.html
{% extends "base.html" %}

{% block title %}Update Task{% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class = "container">
			<div class = "row">
				<div class = "col-6 offset-3">
					<h1 class = "text-center mt-3">Update Task</h1>

					{% if error == True %}
						<p class = "text-danger text-center">Task not found</p>
					{% endif %}
					<form action="{% url 'todolist:update_task' todoitem_id %}" method="POST">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="task_name">Task Name: </label>
						    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
						    <label for="status">Status: </label>
						    <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Update Task">
						</div>

					</form>
				</div>
				
			</div>
		</div>
	{% endif %}

{% endblock %}